diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/TilePos.java b/game/core/src/main/java/net/minecraft/core/world/pos/TilePos.java
index 69c70f02a..b6b2f5a2e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pos/TilePos.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/TilePos.java
@@ -3,27 +3,40 @@ package net.minecraft.core.world.pos;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.chunk.Chunk;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Math;
+import org.joml.Vector3dc;
+import org.joml.Vector3fc;
+import org.joml.Vector3ic;
 
-public final class TilePos
-    implements Pos3i<TilePos> {
+import java.io.Externalizable;
+import java.io.IOException;
+import java.io.ObjectInput;
+import java.io.ObjectOutput;
+
+public final class TilePos implements Externalizable, Cloneable, TilePosc {
     public int x;
     public int y;
     public int z;
 
+    public TilePos() {
+        this.x = 0;
+        this.y = 0;
+        this.z = 0;
+    }
+
     public TilePos(final int x, final int y, final int z) {
         this.x = x;
         this.y = y;
         this.z = z;
     }
 
-    public TilePos(final @NotNull TilePos tilePos) {
-        this(tilePos.x, tilePos.y, tilePos.z);
+    public TilePos(final @NotNull TilePosc tilePos) {
+        this(tilePos.x(), tilePos.y(), tilePos.z());
     }
 
     public TilePos(final float x, final float y, final float z) {
@@ -34,12 +47,24 @@ public final class TilePos
         this(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z));
     }
 
-    public TilePos(final @NotNull ChunkPos chunkPos, final @NotNull ChunkTilePos chunkTilePos) {
-        this(chunkPos.x * Chunk.CHUNK_SIZE_X + chunkTilePos.x, chunkTilePos.y, chunkPos.z * Chunk.CHUNK_SIZE_Z + chunkTilePos.z);
+    public TilePos(final @NotNull ChunkPosc chunkPos) {
+        this(chunkPos.x() * Chunk.CHUNK_SIZE_X, 0, chunkPos.z() * Chunk.CHUNK_SIZE_Z);
+    }
+
+    public TilePos(final @NotNull ChunkPosc chunkPos, final @NotNull ChunkTilePosc chunkTilePos) {
+        this(chunkPos.x() * Chunk.CHUNK_SIZE_X + chunkTilePos.x(), chunkTilePos.y(), chunkPos.z() * Chunk.CHUNK_SIZE_Z + chunkTilePos.z());
+    }
+
+    public TilePos(final @NotNull Vector3dc vec) {
+        this(vec.x(), vec.y(), vec.z());
+    }
+
+    public TilePos(final @NotNull Vector3fc vec) {
+        this(vec.x(), vec.y(), vec.z());
     }
 
-    public TilePos(final @NotNull Vec3 vec) {
-        this(vec.x, vec.y, vec.z);
+    public TilePos(final @NotNull Vector3ic vec) {
+        this(vec.x(), vec.y(), vec.z());
     }
 
     public TilePos(final @NotNull Entity entity) {
@@ -61,14 +86,6 @@ public final class TilePos
         return this.z;
     }
 
-    public @NotNull TilePos add(final int x, final int y, final int z) {
-        return new TilePos(this.x + x, this.y + y, this.z + z);
-    }
-
-    /**
-     * Modifies the position of the tile pos, probably unsafe unless you know modifications will not cause unintended side effects
-     * @return self
-     */
     public @NotNull TilePos set(final int x, final int y, final int z) {
         this.x = x;
         this.y = y;
@@ -76,14 +93,156 @@ public final class TilePos
         return this;
     }
 
-    public @NotNull ChunkPos toChunkPos() {
-        return new ChunkPos(this);
+    public @NotNull TilePos set(final @NotNull TilePosc pos) {
+        this.x = pos.x();
+        this.y = pos.y();
+        this.z = pos.z();
+        return this;
+    }
+
+    @Override
+    public @NotNull TilePos add(int x, int y, int z, @NotNull TilePos dest) {
+        return dest.set(this.x + x, this.y + y, this.z + z);
+    }
+
+    @Override
+    public @NotNull TilePos add(@NotNull Vector3ic v, @NotNull TilePos dest) {
+        return add(v.x(), v.y(), v.z(), dest);
+    }
+
+    @Override
+    public @NotNull TilePos add(@NotNull Direction dir, @NotNull TilePos dest) {
+        return add(dir.getOffsetX(), dir.getOffsetY(), dir.getOffsetZ(), dest);
+    }
+
+    public @NotNull TilePos add(int x, int y, int z) {
+        return add(x, y, z, this);
+    }
+
+    public @NotNull TilePos add(@NotNull Vector3ic v) {
+        return add(v, this);
+    }
+
+    public @NotNull TilePos add(@NotNull Direction dir) {
+        return add(dir, this);
+    }
+
+    @Override
+    public @NotNull TilePos sub(int x, int y, int z, @NotNull TilePos dest) {
+        return dest.set(this.x - x, this.y - y, this.z - z);
     }
 
-    public @NotNull ChunkTilePos toChunkTilePos() {
-        return new ChunkTilePos(this);
+    @Override
+    public @NotNull TilePos sub(@NotNull Vector3ic v, @NotNull TilePos dest) {
+        return sub(v.x(), v.y(), v.z(), dest);
     }
 
+    @Override
+    public @NotNull TilePos sub(@NotNull Direction dir, @NotNull TilePos dest) {
+        return sub(dir.getOffsetX(), dir.getOffsetY(), dir.getOffsetZ(), dest);
+    }
+
+    public @NotNull TilePos sub(int x, int y, int z) {
+        return sub(x, y, z, this);
+    }
+
+    public @NotNull TilePos sub(@NotNull Vector3ic v) {
+        return sub(v, this);
+    }
+
+    public @NotNull TilePos sub(@NotNull Direction dir) {
+        return sub(dir, this);
+    }
+
+    @Override
+    public double distance(@NotNull TilePosc pos) {
+        return distance(pos.x(), pos.y(), pos.z());
+    }
+
+    @Override
+    public double distance(@NotNull Vector3fc v) {
+        return distance(v.x(), v.y(), v.z());
+    }
+
+    @Override
+    public double distance(@NotNull Vector3dc v) {
+        return distance(v.x(), v.y(), v.z());
+    }
+
+    @Override
+    public double distance(@NotNull Entity e) {
+        return distance(e.x, e.y, e.z);
+    }
+
+    @Override
+    public double distance(int x, int y, int z) {
+        int dx = this.x - x;
+        int dy = this.y - y;
+        int dz = this.z - z;
+        return Math.sqrt(dx * dx + dy * dy + dz * dz);
+    }
+
+    @Override
+    public double distance(float x, float y, float z) {
+        float dx = this.x - x;
+        float dy = this.y - y;
+        float dz = this.z - z;
+        return Math.sqrt(dx * dx + dy * dy + dz * dz);
+    }
+
+    @Override
+    public double distance(double x, double y, double z) {
+        double dx = this.x - x;
+        double dy = this.y - y;
+        double dz = this.z - z;
+        return Math.sqrt(dx * dx + dy * dy + dz * dz);
+    }
+
+    @Override
+    public double distanceSquared(@NotNull TilePosc pos) {
+        return distanceSquared(pos.x(), pos.y(), pos.z());
+    }
+
+    @Override
+    public double distanceSquared(@NotNull Vector3fc v) {
+        return distanceSquared(v.x(), v.y(), v.z());
+    }
+
+    @Override
+    public double distanceSquared(@NotNull Vector3dc v) {
+        return distanceSquared(v.x(), v.y(), v.z());
+    }
+
+    @Override
+    public double distanceSquared(@NotNull Entity e) {
+        return distanceSquared(e.x, e.y, e.z);
+    }
+
+    @Override
+    public double distanceSquared(int x, int y, int z) {
+        int dx = this.x - x;
+        int dy = this.y - y;
+        int dz = this.z - z;
+        return dx * dx + dy * dy + dz * dz;
+    }
+
+    @Override
+    public double distanceSquared(float x, float y, float z) {
+        float dx = this.x - x;
+        float dy = this.y - y;
+        float dz = this.z - z;
+        return dx * dx + dy * dy + dz * dz;
+    }
+
+    @Override
+    public double distanceSquared(double x, double y, double z) {
+        double dx = this.x - x;
+        double dy = this.y - y;
+        double dz = this.z - z;
+        return dx * dx + dy * dy + dz * dz;
+    }
+
+    @Override
     public boolean inBounds(final @NotNull WorldSource source) {
         return
             this.x >= World.MIN_BLOCK_X &&
@@ -94,13 +253,71 @@ public final class TilePos
                 this.z <= World.MAX_BLOCK_Z;
     }
 
+    @Override
+    public boolean equals(int x, int y, int z) {
+        return this.x == x && this.y == y && this.z == z;
+    }
+
+    @Override
+    public @NotNull TilePos up(@NotNull TilePos dest) {
+        return add(Direction.UP, dest);
+    }
+
+    public @NotNull TilePos up() {
+        return this.add(Direction.UP);
+    }
+
+    @Override
+    public @NotNull TilePos down(@NotNull TilePos dest) {
+        return add(Direction.DOWN, dest);
+    }
+
+    public @NotNull TilePos down() {
+        return this.add(Direction.DOWN);
+    }
+
+    @Override
+    public @NotNull TilePos north(@NotNull TilePos dest) {
+        return add(Direction.NORTH, dest);
+    }
+
+    public @NotNull TilePos north() {
+        return this.add(Direction.NORTH);
+    }
+
+    @Override
+    public @NotNull TilePos south(@NotNull TilePos dest) {
+        return add(Direction.SOUTH, dest);
+    }
+
+    public @NotNull TilePos south() {
+        return this.add(Direction.SOUTH);
+    }
+
+    @Override
+    public @NotNull TilePos west(@NotNull TilePos dest) {
+        return add(Direction.WEST, dest);
+    }
+
+    public @NotNull TilePos west() {
+        return this.add(Direction.WEST);
+    }
+
+    @Override
+    public @NotNull TilePos east(@NotNull TilePos dest) {
+        return add(Direction.EAST, dest);
+    }
+
+    public @NotNull TilePos east() {
+        return this.add(Direction.EAST);
+    }
+
     @Override
     public boolean equals(final @Nullable Object obj) {
-        if (!(obj instanceof final @NotNull TilePos other)) {
-            return false;
-        } else {
+        if (obj instanceof final @NotNull TilePos other) {
             return this.x == other.x && this.y == other.y && this.z == other.z;
         }
+        return false;
     }
 
     @Override
@@ -110,10 +327,23 @@ public final class TilePos
 
     @Override
     public String toString() {
-        return "TilePos{" +
-            "x=" + x +
-            ", y=" + y +
-            ", z=" + z +
-            '}';
+        return "(" + this.x + " " + this.y + " " + this.z + ")";
+    }
+
+    @Override
+    public void writeExternal(ObjectOutput out) throws IOException {
+        out.writeInt(this.x);
+        out.writeInt(this.y);
+        out.writeInt(this.z);
+    }
+
+    @Override
+    public void readExternal(ObjectInput in) throws IOException, ClassNotFoundException {
+        set(in.readInt(), in.readInt(), in.readInt());
+    }
+
+    @Override
+    protected Object clone() throws CloneNotSupportedException {
+        return super.clone();
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/TilePosc.java b/game/core/src/main/java/net/minecraft/core/world/pos/TilePosc.java
new file mode 100644
index 000000000..e5c2fc578
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/TilePosc.java
@@ -0,0 +1,80 @@
+package net.minecraft.core.world.pos;
+
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
+import org.joml.Vector3dc;
+import org.joml.Vector3fc;
+import org.joml.Vector3ic;
+
+/**
+ * Tile pos relative to the world
+ */
+public interface TilePosc {
+    int x();
+
+    int y();
+
+    int z();
+
+    @NotNull TilePos add(int x, int y, int z, @NotNull TilePos dest);
+
+    @NotNull TilePos add(@NotNull Vector3ic v, @NotNull TilePos dest);
+
+    @NotNull TilePos add(@NotNull Direction dir, @NotNull TilePos dest);
+
+    @NotNull TilePos sub(int x, int y, int z, @NotNull TilePos dest);
+
+    @NotNull TilePos sub(@NotNull Vector3ic v, @NotNull TilePos dest);
+
+    @NotNull TilePos sub(@NotNull Direction dir, @NotNull TilePos dest);
+
+    double distance(@NotNull TilePosc pos);
+
+    double distance(@NotNull Vector3fc v);
+
+    double distance(@NotNull Vector3dc v);
+
+    double distance(@NotNull Entity e);
+
+    double distance(int x, int y, int z);
+
+    double distance(float x, float y, float z);
+
+    double distance(double x, double y, double z);
+
+    double distanceSquared(@NotNull TilePosc pos);
+
+    double distanceSquared(@NotNull Vector3fc v);
+
+    double distanceSquared(@NotNull Vector3dc v);
+
+    double distanceSquared(@NotNull Entity e);
+
+    double distanceSquared(int x, int y, int z);
+
+    double distanceSquared(float x, float y, float z);
+
+    double distanceSquared(double x, double y, double z);
+
+    boolean inBounds(final @NotNull WorldSource source);
+
+    boolean equals(int x, int y, int z);
+
+    @NotNull TilePos up(@NotNull TilePos dest);
+
+    @NotNull TilePos down(@NotNull TilePos dest);
+
+    @NotNull TilePos north(@NotNull TilePos dest);
+
+    @NotNull TilePos south(@NotNull TilePos dest);
+
+    @NotNull TilePos west(@NotNull TilePos dest);
+
+    @NotNull TilePos east(@NotNull TilePos dest);
+
+    default boolean equals(final @NotNull TilePosc tilePos) {
+        return this.x() == tilePos.x() && this.y() == tilePos.y() && this.z() == tilePos.z();
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherStorm.java b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherStorm.java
index 6121096ba..d65abcd87 100644
--- a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherStorm.java
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherStorm.java
@@ -4,9 +4,9 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.EntityLightning;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBd;
 
 import java.util.List;
 import java.util.Random;
@@ -66,7 +66,7 @@ public class WeatherStorm extends WeatherRain {
         weight += checkY;
         weight += material.getConductivity();
 
-        final @NotNull List<@NotNull Mob> entityList = world.getEntitiesWithinAABB(Mob.class, AABB.fromPool(checkX, checkY, checkZ, checkX + 1, checkY + 1, checkZ + 1));
+        final @NotNull List<@NotNull Mob> entityList = world.getEntitiesWithinAABB(Mob.class, new AABBd(checkX, checkY, checkZ, checkX + 1, checkY + 1, checkZ + 1));
         if (!entityList.isEmpty()) {
             weight += 4; // :)
         }
diff --git a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
index e296a9216..3fbab845a 100644
--- a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
@@ -23,6 +23,7 @@ import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkSection;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.server.entity.EntityTrackerImpl;
 import net.minecraft.server.net.handler.PacketHandlerServer;
 import net.minecraft.core.net.packet.*;
@@ -31,14 +32,13 @@ import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.player.inventory.slot.SlotResult;
 import net.minecraft.core.util.helper.AES;
 import net.minecraft.core.util.helper.DamageType;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.server.world.WorldServer;
 import net.minecraft.core.world.chunk.ChunkCoordinate;
-import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.server.MinecraftServer;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 
 import java.util.ArrayList;
 import java.util.HashSet;
@@ -115,7 +115,7 @@ public class PlayerServer extends Player implements ContainerListener {
     }
 
     @Override
-	public AABB getBb()
+	public @Nullable AABBdc getCollisionAABB()
     {
         if (noPhysics)
         {
@@ -123,7 +123,7 @@ public class PlayerServer extends Player implements ContainerListener {
         }
         else
         {
-            return super.getBb();
+            return super.getCollisionAABB();
         }
     }
 
@@ -490,7 +490,7 @@ public class PlayerServer extends Player implements ContainerListener {
     }
 
     @Override
-	public void displayWorkbenchScreen(@NotNull TilePos tilePos)
+	public void displayWorkbenchScreen(@NotNull TilePosc tilePos)
     {
         getNextWindowId();
         playerNetServerHandler.sendPacket(new PacketContainerOpen(currentWindowId, PacketContainerOpen.TYPE_CRAFTING, "Crafting", 9));
diff --git a/game/server/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java b/game/server/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java
index 2d3a259a6..018cb51b8 100644
--- a/game/server/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java
+++ b/game/server/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java
@@ -7,11 +7,12 @@ import net.minecraft.core.net.packet.PacketChat;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.util.helper.AES;
 import net.minecraft.core.util.helper.LoggedPrintStream;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.server.MinecraftServer;
 import net.minecraft.server.entity.player.PlayerServer;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3dc;
 import org.slf4j.Logger;
 
 import java.util.ArrayList;
@@ -67,12 +68,12 @@ public class ConsoleCommandSource implements CommandSource, IServerCommandSource
     }
 
     @Override
-    public @Nullable Vec3 getCoordinates(boolean offsetHeight) {
+    public @Nullable Vector3dc getCoordinates(boolean offsetHeight) {
         return null;
     }
 
     @Override
-    public @Nullable Vec3 getBlockCoordinates() {
+    public @Nullable TilePosc getBlockCoordinates() {
         return null;
     }
 
diff --git a/game/server/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java b/game/server/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
index 2f3b13fad..d22bdf7ce 100644
--- a/game/server/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
+++ b/game/server/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
@@ -5,12 +5,15 @@ import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.packet.PacketChat;
 import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.util.helper.AES;
-import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.server.MinecraftServer;
 import net.minecraft.server.entity.player.PlayerServer;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
 
 import java.util.ArrayList;
 import java.util.Collection;
@@ -29,7 +32,7 @@ public class ServerCommandSource implements CommandSource, IServerCommandSource
     @Override
     public Collection<String> getPlayerUsernames() {
         List<String> list = new ArrayList<>();
-        for (Player player : server.playerList.playerEntities) {
+        for (Player player : this.server.playerList.playerEntities) {
             list.add(player.username);
         }
         return list;
@@ -38,7 +41,7 @@ public class ServerCommandSource implements CommandSource, IServerCommandSource
     @Override
     public Collection<String> getPlayerNicknames() {
         List<String> list = new ArrayList<>();
-        for (Player player : server.playerList.playerEntities) {
+        for (Player player : this.server.playerList.playerEntities) {
             list.add(player.nickname);
         }
         return list;
@@ -65,16 +68,17 @@ public class ServerCommandSource implements CommandSource, IServerCommandSource
     }
 
     @Override
-    public @NotNull Vec3 getCoordinates(boolean offsetHeight) {
-        Vec3 position = this.getSender().getPosition(1.0f, false);
-        if (offsetHeight) return position.add(0.0f, -this.getSender().heightOffset, 0.0f);
+    public @Nullable Vector3dc getCoordinates(boolean offsetHeight) {
+        Vector3dc position = this.getSender().getPosition(1.0f, false);
+        if (offsetHeight) return position.add(0.0f, -this.getSender().heightOffset, 0.0f, new Vector3d());
         return position;
     }
 
     @Override
-    public @NotNull Vec3 getBlockCoordinates() {
-        Vec3 coordinates = this.getCoordinates(true);
-        return Vec3.fromPool(MathHelper.floor(coordinates.x), MathHelper.floor(coordinates.y), MathHelper.floor(coordinates.z));
+    public @Nullable TilePosc getBlockCoordinates() {
+        Vector3dc coordinates = this.getCoordinates(true);
+        assert coordinates != null;
+        return new TilePos(coordinates);
     }
 
     @Override
diff --git a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java
index cf67bfa41..24883401e 100644
--- a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java
+++ b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java
@@ -19,8 +19,8 @@ import net.minecraft.core.util.helper.AES;
 import net.minecraft.core.util.helper.RSA;
 import net.minecraft.core.util.helper.RestHandler;
 import net.minecraft.server.world.WorldServer;
-import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.server.MinecraftServer;
+import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
 import java.io.BufferedReader;
@@ -97,26 +97,26 @@ public class PacketHandlerLogin extends PacketHandler
     }
 
     @Override
-	public void handleHandshake(PacketPreLogin preLoginPacket)
+	public void handleHandshake(@NotNull PacketHandshake packetHandshake)
     {
         if (mcServer.onlineMode)
         {
             serverId = Long.toHexString(rand.nextLong());
-            netManager.addToSendQueue(new PacketPreLogin(serverId));
+            netManager.addToSendQueue(new PacketHandshake(serverId));
         }
         else
         {
-            netManager.addToSendQueue(new PacketPreLogin("-"));
+            netManager.addToSendQueue(new PacketHandshake("-"));
         }
     }
 
     @Override
-	public void handleLogin(PacketLogin loginPacket)
+	public void handleLogin(@NotNull PacketLogin packetLogin)
     {
-        username = loginPacket.username;
-        if (loginPacket.playerEntityIdAndProtocolVersion != Global.MP_PROTOCOL_VERSION)
+        username = packetLogin.username;
+        if (packetLogin.playerEntityIdAndProtocolVersion != Global.MP_PROTOCOL_VERSION)
         {
-            if (loginPacket.playerEntityIdAndProtocolVersion > Global.MP_PROTOCOL_VERSION)
+            if (packetLogin.playerEntityIdAndProtocolVersion > Global.MP_PROTOCOL_VERSION)
             {
                 kickUser("Outdated server!");
             }
@@ -128,7 +128,7 @@ public class PacketHandlerLogin extends PacketHandler
         }
         if (!mcServer.onlineMode)
         {
-            doLogin(loginPacket);
+            doLogin(packetLogin);
         }
         else
         {
@@ -137,13 +137,13 @@ public class PacketHandlerLogin extends PacketHandler
                     try
                     {
                         String s = PacketHandlerLogin.getServerId(this);
-                        URL url = new URL("http://session.minecraft.net/game/checkserver.jsp?user=" + URLEncoder.encode(loginPacket.username, "UTF-8") + "&serverId=" + URLEncoder.encode(s, "UTF-8"));
+                        URL url = new URL("http://session.minecraft.net/game/checkserver.jsp?user=" + URLEncoder.encode(packetLogin.username, "UTF-8") + "&serverId=" + URLEncoder.encode(s, "UTF-8"));
                         BufferedReader bufferedreader = new BufferedReader(new InputStreamReader(url.openStream()));
                         String s1 = bufferedreader.readLine();
                         bufferedreader.close();
                         if(s1.equals("YES"))
                         {
-                            PacketHandlerLogin.setLoginPacket(this, loginPacket);
+                            PacketHandlerLogin.setLoginPacket(this, packetLogin);
                         } else
                         {
                             this.kickUser("Failed to verify username!");
@@ -239,9 +239,9 @@ public class PacketHandlerLogin extends PacketHandler
     }
 
     @Override
-    public void handlePingHandshake(PacketPingHandshake pingHandshakePacket) {
+    public void handlePingHandshake(@NotNull PacketPingHandshake packetPingHandshake) {
         StringBuilder msg = new StringBuilder();
-        switch (pingHandshakePacket.pingHostString) {
+        switch (packetPingHandshake.pingHostString) {
             case "MC|PingHost":
                 msg
                     .append("§1").append('\0')
@@ -252,7 +252,7 @@ public class PacketHandlerLogin extends PacketHandler
                     .append(0);
                 break;
             case "BTAPingHost":
-                switch (pingHandshakePacket.payload) {
+                switch (packetPingHandshake.payload) {
                     case 0x02: {
                         msg
                             .append("§1").append('\0')
@@ -306,7 +306,7 @@ public class PacketHandlerLogin extends PacketHandler
     }
 
     @Override
-	public void handleInvalidPacket(Packet packet)
+	public void handleInvalidPacket(@NotNull Packet packet)
     {
         if (kickMessage != null) {
             kickUser(kickMessage);
